# calculate the index
# define an overall benchmark, choose the minimum value of each year and index
# define a group-wise benchmark, choose the minimum value of each year and index of every group
source("/Users/siyan/Desktop/Supplementary material/Part III/R software code/Example_hclust.R");

bench <- matrix(,GL_ntp,GL_nindex)
for (iyear in 1:GL_ntp)
{
  for (v in 1:GL_nindex)
  {
    bench[iyear,v]<-min(GL_myData[iyear,v,])
  }
}

calDisObsbench <- function(obs_i,bench,weightt,weightv,type){
  obsi <- GL_myData[,,obs_i];
  # obsj <- myData[,,obs_j];
  dis <- 0;
  for (v in 1:GL_nindex)#indices
  {
    if(type==1)
    {
      tmpdis <- sum(weightt*(obsi[,v]-bench[,v])^2)/sum((GL_poolSDs[,v])^2); 
    }else if(type==2)
    {
      tmpdis <- sum(weightt*((obsi[,v]-bench[,v])/GL_poolSDs[,v])^2);
    }else{
      tmpdis <- sum(weightt*(obsi[,v]-bench[,v])^2)
    }
    dis <- dis+weightv[v]*tmpdis;
  }
  return(dis);
}

dis2bench <- rep(0,33);
for(j in 1:33)
{ #dis between jth obs and the benchmark
  dis2bench[j] <- calDisObsbench(j,bench,weightt=GL_weightt,weightv=GL_weightv,type=GL_disType);
}


# calculate the average distances to benchmark of every group
groupdis<-rep(0,GL_k)
for(i in 1:GL_k)
{
  groupdis[i] <- mean(dis2bench[which(rcls==i)]);
}
groupord<-order(groupdis,decreasing=T)







