library(readxl)
happy <- list()#raw data
p <- 15;
n <- 33;
nindex <- 18
nmst <- rep(0,15); #number of missing values by time points
for (m in 1:nindex) 
{
  #p*n
  happy[[m]] <- apply(t(as.matrix(read_xlsx("/Users/siyan/Desktop/Supplementary material/Part III/R software code/originaldata.xlsx",sheet=m))[,-1]),2,as.numeric)
  tmp <- is.na(happy[[m]]);
  nmst <- nmst + rowSums(tmp);
}

#transform nmst log directly & polynomial fit
tmpDF <- data.frame(x=1:p,y=log(nmst));
mymdl <- lm(y ~ poly(x,2), data=tmpDF);#mymdl <- loess(y ~ x, data=tmpDF, span=0.75, control=loess.control(surface="direct"),degree=2);#defaults "span=0.75"
myfit <- exp(predict(mymdl,data.frame(x = 1:p)));
print(myfit)
mycolor <- rgb(red=runif(1),green=runif(1),blue=runif(1));
plot(1:p,myfit,ylim=c(min(myfit),max(myfit)),type='l',xaxt="n",col=mycolor, ylab=paste("#missing"),,xlab = "Year");
axis(1,at=1:15,labels=c(2005:2019),cex.axis=1)
points(1:p,nmst,col=mycolor);

Invweight_fit=(1/myfit)/sum(1/myfit);
print(Invweight_fit);
saveRDS(Invweight_fit,"/Users/siyan/Desktop/Supplementary material/Part III/R software code/weighttms.RDS")
