library(readxl)
source("/Users/siyan/Desktop/sustainability/FDregsmooth.R")
# generate smoothed data
p <- 15#100;
nindex <- 18; 
Ytp <- (0:(p-1))/(p-1);
Ftp <- (0:(p-1))/(p-1);
dm <- list() # smoothed data, list NO: 18 variables , matrix p*n: 15*33, 15 is year number and 33 is city number   
happy <- list() # raw data
newMeans <- list()
fileName <- "/Users/siyan/Desktop/sustainability/originaldata.xlsx";
for (m in 1:nindex)
{
  happy[[m]] <- apply(t(as.matrix(read_xlsx(fileName,sheet=m))[,-1]),2,as.numeric)
  happys <- MX2FD_lpk2(happy[[m]],Ytp,Ftp,span=0.75,degree=2);#happy[[m]]#no smooth
  dm[[m]] <- happys;
  #plot
  Y <- happys; Yo <- happy[[m]];
  mycolor <- rgb(red=runif(1),green=runif(1),blue=runif(1));
  plot(Ftp,Y[,1],ylim=c(min(Y),max(Y)),type='l',col=mycolor);
  points(Ytp,Yo[,1],col=mycolor);
  for(i in 2:ncol(Y))
  {
    mycolor <- rgb(red=runif(1),green=runif(1),blue=runif(1));
    lines(Ftp,Y[,i],col=mycolor);
    points(Ytp,Yo[,i],col=mycolor);
  }
  #i=i+1; mycolor <- rgb(red=runif(1),green=runif(1),blue=runif(1));plot(Ftp,Y[,i],ylim=c(min(Y),max(Y)),type='l',col=mycolor, ylab=paste("i=",i));points(Ytp,Yo[,i],col=mycolor);
}

dmnew <- array(dim=c(15,nindex,33)) # smoothed data, list NO: 33 cities , matrix p*v: 15*20, 15 is year number and 18 is variable number   
for (i in 1:33)
{
  for (j in 1: nindex)
  {
    dmnew[,j,i] <- dm[[j]][,i]
  }
}
saveRDS(dmnew,file="/Users/siyan/Desktop/sustainability/datasmnew830.Rds")



