# use hierarchical clustering to form initial clusters 
inithier <- function(k,type,method="complete"){
  d <- matrix(0,GL_nobs,GL_nobs);
  for (i in 1:(GL_nobs-1))
  {
    for (j in (i+1):GL_nobs)
    {
      #weightt,weightv: use global values
      #type: use input
      d[i,j]<-calDisObs(i,j,GL_weightt,GL_weightv,type);
      d[j,i]<-d[i,j];
    }
  }
  disclust<-as.dist(sqrt(d));
  if(method!="minimax")
  {
    hresult<-hclust(disclust,method);#plot(hresult)
  }else{
    require("protoclust");
    hresult<-protoclust(disclust);#plot(hresult)
  }
  #memb <- cutree(hresult,k);print("memb=");print(memb);
  #return(memb);
  return(hresult);
}

# initkmeans4 <- function(k){
#   #  initcls <-inithier(4,1);
#   #  initcls <- c(3,2,4,3,4,4,3,1,3,3,2,3,4,1,3,3,4,1,2,1,3,3,1,2,1,1,3,3,2,3,2,2,1) # type 1
#   #  initcls <- c(3,1,4,3,4,4,3,2,1,3,1,3,4,3,3,3,4,3,1,3,3,3,2,1,2,3,3,1,3,3,1,1,2) # type 2
#   #need define initcls outside this function first!
#   for (ic in 1:k)
#   {
#     clsind <- (initcls==ic);
#     if(sum(clsind)>1)
#     {
#       for (v in 1:nindex)
#       {
#         datacv <- myData[,v,clsind];
#         newMeans[,v,ic] <<- apply(datacv,1,mean) # calculate the initial k means
#         newSDs[,v,ic] <<- apply(datacv,1,sd) # calculate the initial k sds
#       }#end of for
#     }else if(sum(clsind)==1)
#     {
#       for (v in 1:nindex)
#       {
#         datacv <- myData[,v,clsind];
#         newMeans[,v,ic] <<- datacv; # calculate the initial k means
#         #newSDs[,v,ic] <<- apply(datacv,1,sd) # calculate the updated k sds
#       }#end of for
#     }#end of if
#   }#end of for ic
# }

initkmeans4 <- function(k){
  #  initcls <-inithier(4,1);
  #need define initcls outside this function first!
  for (ic in 1:k)
  {
    calCenter(ic,GL_initcls,GL_disType,GL_centerType);
  }#end of for ic
}